Drupal.theme.prototype.mkdruResult = function(hit, num, detailLink) {
  var html = "";
  html += '<li class="mkdru-result" id="rec_' + hit.recid + '" >'
          + '<span>' + num + '. </span>'
          + '<a href="' + detailLink + '" class="mkdru-result-title">'
          + hit["md-title"] + '</a> ';
  if (hit["md-title-remainder"] !== undefined) {
    html += '<span class="mkdru-result-title-remainder">' 
            + hit["md-title-remainder"] + ' </span>';
  }
  if (hit["md-title-responsibility"] !== undefined) {
    html += '<span class="mkdru-result-author"><i>'
            + hit["md-title-responsibility"]
            + '</i></span>';
  }
  html += '</li>';
  return html;
};

Drupal.theme.prototype.mkdruDetail = function(data, linkBack) {
  var html = '<table id="det_' + data.recid +'">';
  if (data["md-title"] != undefined) {
    html += '<tr><th>' + Drupal.t("Title") + '</th><td><strong>:</strong> '
            + data["md-title"];
    if (data["md-title-remainder"] !== undefined) {
      html += ' : <span>' + data["md-title-remainder"] + ' </span>';
    }
    if (data["md-title-responsibility"] !== undefined) {
      html += ' <span><i>'+ data["md-title-responsibility"] +'</i></span>';
    }
    html += '</td></tr>';
  }
  if (data["md-date"] != undefined)
    html += '<tr><th>' + Drupal.t("Date") + '</th><td><strong>:</strong> '
            + data["md-date"] + '</td></tr>';
  if (data["md-author"] != undefined)
    html += '<tr><th>' + Drupal.t("Author") + '</th><td><strong>:</strong> '
            + data["md-author"] + '</td></tr>';
  if (data["md-electronic-url"] != undefined)
    html += '<tr><th>URL</th><td><strong>:</strong> <a href="'
            + data["md-electronic-url"] + '" target="_blank">'
            + data["md-electronic-url"] + '</a>' + '</td></tr>';
  if (data["location"][0]["md-subject"] != undefined)
    html += '<tr><th>' + Drupal.t("Subject") + '</th><td><strong>:</strong> '
            + data["location"][0]["md-subject"] + '</td></tr>';
  if (data["location"][0]["@name"] != undefined)
    html += '<tr><th>' + Drupal.t("Location") + '</th></td><td><strong>:</strong> '
            + data["location"][0]["@name"] + " (" + data["location"][0]["@id"] + ")"
            + '</td></tr>';
  html += '</table></div>';
  html += '<a href="' + linkBack + '">Return to result list...</a>';
  return html;
};

/**
 * Pager theme
 *
 * @param pages
 *   Array of hrefs for page links.
 * @param start
 *   Number of first page.
 * @param current
 *   Number of current page.
 * @param total
 *   Total number of pages.
 * @param prev
 *   Href for previous page.
 * @param next
 *   Href for next page.
 */
Drupal.theme.prototype.mkdruPager = function (pages, start, current, total, prev, next) {
  var html = "";
  if (prev) 
    html += '<a href="' + prev + '" class="mkdru-pager-prev">&#60;&#60; '
            + Drupal.t("Prev") + '</a> | ';
  else
    html += '<span class="mkdru-pager-prev">&#60;&#60; ' + Drupal.t("Prev")
            + '</span> | ';

  if (start > 1)
    html += '...';

  for (var i = 0; i < pages.length; i++) {
    if (i + start == current)
      html += ' <span class="mkdru-pager-current">' + (i + start) + '</span>';
    else
      html += ' <a href="' + pages[i] + '">' + (i + start) + '</a>';
  }

  if (total > i)
    html += ' ...';

  if (next)
    html += ' | <a href="' + next + '" class="mkdru-pager-next">'
      + Drupal.t("Next") + ' &#62;&#62;</a>';
  else
    html += ' | <span class="mkdru-pager-next">' + Drupal.t("Next")
            + ' &#62;&#62;</span>';

  return html;
};

Drupal.theme.prototype.mkdruCounts = function(first, last, available, total) {
  return first + Drupal.t(' to ') + last + Drupal.t(' of ') + available
         + Drupal.t(' available (') + total + Drupal.t(' found)');
};

Drupal.theme.prototype.mkdruStatus = function(activeClients, clients) {
  return Drupal.t('Waiting on ') + activeClients + Drupal.t(' out of ')
         + clients + Drupal.t(' targets');
};

Drupal.theme.prototype.mkdruFacet = function (terms, facet, max) {
  var html = "";
  for (var i = 0; i < terms.length && i < max; i++ ) {
    html += Drupal.theme('mkdruFacetTerm', terms[i], facet);
  }
  return html;
};

Drupal.theme.prototype.mkdruFacetTerm = function (term, facet) {
  var html = '<a href="';
  switch (facet) {
    case 'source':
      html += mkdru.hashAddDelOne('limit_' + facet, term.id, 'page');
      break;
    case 'subject':
    case 'author':
      html += mkdru.hashAddDelOne('limit_' + facet, term.name, 'page');
      break;
  }
  html += '">' + term.name + '</a><span> (' + term.freq + ')</span><br/>';
  return html;
};

Drupal.theme.prototype.mkdruFacetLimit = function (term, link) {
  if (term) {
    return '<p>' + Drupal.t('Only displaying ') + term.name + '</p>'
      + '<p><a href="' + link + '">' + Drupal.t('Show all...') + '</a></p>';
  }
};